list p=12f508
#include P12F508.INC
__config _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC

;********************************************************************
;* Registres                                                        *
;********************************************************************
TMP      equ    H'0007'
S1A      equ    H'0008'
S1B      equ    H'0009'
S2A      equ    H'000A'
S2B      equ    H'000B'
S3A      equ    H'000C'
S3B      equ    H'000D'
S4A      equ    H'000E'
S4B      equ    H'000F'
S5A      equ    H'0010'   
S5B      equ    H'0011'
MUX      equ    H'0012'
PROGRAM  equ    H'0013'
VITESS   equ    H'0014'
CPTRVTS  equ    H'0015'
MOTIF1   equ    H'0016'
MOTIF2   equ    H'0017'
MOTIF3   equ    H'0018'
MOTIF4   equ    H'0019'
MOTIF5   equ    H'001A'
ETAPE    equ    H'001B'
BOUTON   equ    H'001C'
C50MS    equ    H'001D'


;********************************************************************
;*     constantes                                                   *
;********************************************************************
vitesse  equ    d'10'   ; vitesse de dfilement au dmarrage en hz 
freq_mux equ    d'100' ; frequence de multiplex en hz

;********************************************************************
;*     Dmarrage                                                    *
;********************************************************************
        org 0x00
        movwf    OSCCAL
        btfss    STATUS,GPWUF  ; si reveil aller  debut:
        goto    Init          ; sinon initialiser les variables 
        goto    Debut
Vprog:    goto    Prog        ;vecteur du sous programme Prog et Anim
Vanim:    goto    Anim        ;doit se trouver dans les 256 premieres instructions


;********************************************************************
;*     Initialisation des varialbles                                *
;********************************************************************
Init:    movlw    B'01010101'
        option
        movlw    B'00111111'
        tris    GPIO
        movlw    D'1'
        movwf    MUX
        clrf    PROGRAM
        call    Vprog
        clrf    ETAPE
        clrf    BOUTON
        movlw    freq_mux / vitesse
        movwf    VITESS
        clrf    CPTRVTS
        clrf    TMR0

;********************************************************************
;*     Programme principal                                          *
;********************************************************************
;*     Gestion du bouton                                            *
;********************************************************************
Debut:  btfss    GPIO,h'3'
        goto    Bton
        goto    Btoff

Bton:    btfsc    BOUTON,d'6'    ;si bouton appuy avant
        goto    Bton1        ; continuer
        clrf    C50MS        ;sinon reset du timer 50ms
        bsf        BOUTON,d'6'
        goto    Timer
Bton1:    movlw    freq_mux / d'20'
        xorwf    C50MS,W
        btfss    STATUS,Z    ;si 50ms non coul
        goto    Timer        ; quitter le gestion du bouton
        clrf    C50MS        ;sinon reset de C50MS
        incf    BOUTON,F    ; et incrementer BOUTON
        movlw    b'00111111'
        andwf    BOUTON,W
        xorlw    d'15'
        btfss    STATUS,Z    ; si BOUTON<>15
        goto    Bton2        ;aller  Bton2
        movlw    b'11000000'
        andwf    BOUTON,F
        movlw    d'11'
        addwf    BOUTON,F    ;sinon BOUTON=11
Bton2:    movlw    b'00111111'
        andwf    BOUTON,W
        xorlw    d'11'
        btfss    STATUS,Z    ;si Bouton <> 11
        goto    Timer        ; Quitter la gestion du bouton
        btfsc    BOUTON,d'7'    ; sinon tester le bit inc/dec VITESS
        goto    Btdown        ;si 1 aller  Btdown
                            ;sinon aller  Btup
Btup:    decfsz    VITESS,F
Btup1:    goto    Timer
        incf    VITESS
        goto    Timer

Btdown:    incfsz    VITESS,F
        goto    Timer
        movlw    d'255'
        movwf    VITESS
        goto    Timer

Btoff:    movlw    b'00111111'
        andwf    BOUTON,W
        btfsc    STATUS,Z    ;si avant le bouton tait relach
        goto    Timer        ;quitter la gestion du bouton
        movwf    TMP
        movlw    d'10'
        subwf    TMP,W        ;
        btfss    STATUS,C    ;si < 500ms
        goto    Btprg        ;changer de programme
        movlw    b'10000000'
        andwf    BOUTON,F    ; sinon reset de BOUTON
        movlw    b'10000000'
        xorwf    BOUTON,F    ; invertion du bit inc/dec vitesse
        goto    Timer        ;quitter la gestion du bouton

Btprg:    incf    PROGRAM,F
        call    Vprog
        movlw    b'10000000'    
        andwf    BOUTON,F    ; reset de BOUTON


;********************************************************************
;*     Gestion du timer                                             *
;********************************************************************
Timer:    movf    TMR0,W
        btfss    STATUS,Z    ;si TRM0=0 
        goto    Debut        ;sinon retour au debut
;********************************************************************
;*     Gestion de l'animation                                       *
;********************************************************************
        movlw    d'1'
        xorwf    MUX,W
        btfss    STATUS,Z    ; si MUX=1 continer (Dbut du multiplex)
        goto    Mux1        ; sinon allez  Mux1
        incf    C50MS,F        ; C50MS=C50MS+1
        incf    CPTRVTS,F    ; CPTRVTS=CPTRVTS+1
        movf    VITESS,W
        xorwf    CPTRVTS,W
        btfss    STATUS,Z    ;si CPTRVTS<VITESS
        goto    Mux1        ;aller  Mux1
        clrf    CPTRVTS        ;sinon reset de CPTRVTS
        call    Vanim        ;et changer l'affichage des leds
;********************************************************************
;*     Gestion du multiplex                                         *
;********************************************************************
Mux1:    movlw    d'255' - ((d'15625' / freq_mux) / d'15') ; 
        btfsc    MUX,h'0'
        movlw    d'255' - ((d'31250' / freq_mux) / d'15') ;
        movwf    TMR0
        movlw    b'11111111'
        tris    GPIO        ; GPIO en entre

        movlw    d'01'
        subwf    MUX,W
        andlw    b'11111110'
        addwf    PCL,F
        movlw    b'11011111'
        goto    Mux2
        movlw    b'11101111'
        goto    Mux2
        movlw    b'11111011'
        goto    Mux2
        movlw    b'11111101'
        goto    Mux2
        movlw    b'11111110'
Mux2:    movwf    GPIO
        movwf    TMP

        movlw    h'07'
        addwf    MUX,W
        movwf    FSR
        movf    INDF,W
        andwf    TMP,W
        TRIS    GPIO

        movlw    d'10'
        xorwf    MUX,W
        btfsc    STATUS,Z
        clrf    MUX
        incf    MUX,F
        goto     Debut        

;********************************************************************
;*     Chargement programme                                         *
;********************************************************************
Prog:    movlw    d'254'-((Anim-Prog)+(Fin-Convert))/64
        subwf    TMR0,W
        btfss    STATUS,C
        goto    Prog1
        movlw    d'254'-((Anim-Prog)+(Fin-Convert))/64
        movwf    TMR0
Prog1:    movlw    d'10'
        subwf    PROGRAM,W
        btfsc    STATUS,C
        clrf    PROGRAM
        clrf    ETAPE
        movf    PROGRAM,W
        movwf    TMP
        rrf        TMP,F
        movlw    d'0'
        xorwf    TMP,W
        btfsc    STATUS,Z
        goto    Prg0
        movlw    d'1'
        xorwf    TMP,W
        btfsc    STATUS,Z
        goto    Prg1
        movlw    d'2'
        xorwf    TMP,W
        btfsc    STATUS,Z
        goto    Prg2
        movlw    d'3'
        xorwf    TMP,W
        btfsc    STATUS,Z
        goto    Prg3
        movlw    d'4'
        xorwf    TMP,W
        btfsc    STATUS,Z
        goto    Prg4
            

Prg0:    movlw    b'00000111'   ;                                 __-X
        movwf    MOTIF1
        movlw    b'00011101'   ;                             _-X-
        movwf    MOTIF2
        movlw    b'01110100'   ;                         -X-_
        movwf    MOTIF3
        movlw    b'11010000'   ;                     X-__
        movwf    MOTIF4
        movlw   b'01000001'   ;                 -__-
        movwf    MOTIF5
        goto    Convert

Prg1:    movlw    b'00000011'   ;                                 ___X
        movwf    MOTIF1
        movlw    b'00001100'   ;                             __X_
        movwf    MOTIF2
        movlw    b'00110000'   ;                         _X__
        movwf    MOTIF3
        movlw    b'11000000'   ;                     X___
        movwf    MOTIF4
        clrf    MOTIF5        ;                 ____
        goto    Convert

Prg2:    movlw    b'00011101'   ;                                 _-X-
        movwf    MOTIF1
        clrf    MOTIF2        ;                             ____    
        clrf    MOTIF3        ;                         ____
        clrf    MOTIF4        ;                     ____
        clrf    MOTIF5        ;                 ____
        goto    Convert

Prg3:    movlw    b'00000011'   ;                                 ___X
        movwf    MOTIF1
        clrf    MOTIF2        ;                             ____
        clrf    MOTIF3        ;                         ____
        clrf    MOTIF4        ;                     ____
        clrf    MOTIF5        ;                 ____
        goto    Convert

Prg4:    movlw    b'01011011'   ;                                 ..-X
        movwf    MOTIF1
        movlw    b'01101110'   ;                             .-X-
        movwf    MOTIF2
        movlw    b'10111001'   ;                         -X-.
        movwf    MOTIF3
        movlw    b'11100101'   ;                     X-..
        movwf    MOTIF4
        movlw   b'10010110'   ;                 -..-
        movwf    MOTIF5
        goto    Convert


;********************************************************************
;*     Animation                                                    *
;********************************************************************
Anim:    movlw    d'254'-(Fin-Anim)/64
        subwf    TMR0,W
        btfss    STATUS,C
        goto    Anim1
        movlw    d'254'-(Fin-Anim)/64
        movwf    TMR0
Anim1:    movlw    d'40'
        xorwf    ETAPE,W
        btfsc    STATUS,Z
        clrf    ETAPE
        movlw    d'20'
        subwf    ETAPE,W
        btfsc    STATUS,C
        goto    Rdroit
        movlw    b'00000001'
        andwf    PROGRAM,W
        btfss    STATUS,Z
        goto    Rgauch

Rdroit: rlf        MOTIF5,W
        rlf        MOTIF1,F
        rlf        MOTIF2,F
        rlf        MOTIF3,F
        rlf        MOTIF4,F
        rlf        MOTIF5,F
        rlf        MOTIF5,W
        rlf        MOTIF1,F
        rlf        MOTIF2,F
        rlf        MOTIF3,F
        rlf        MOTIF4,F
        rlf        MOTIF5,F
        incf    ETAPE,F
        goto    Convert
        
Rgauch:    rrf        MOTIF1,W
        rrf        MOTIF5,F
        rrf        MOTIF4,F
        rrf        MOTIF3,F
        rrf        MOTIF2,F
        rrf        MOTIF1,F
        rrf        MOTIF1,W
        rrf        MOTIF5,F
        rrf        MOTIF4,F
        rrf        MOTIF3,F
        rrf        MOTIF2,F
        rrf        MOTIF1,F
        incf    ETAPE,F
        goto    Convert

;********************************************************************
;*     convertion du motif en etat des sorties                      *
;********************************************************************
Convert:movf    MOTIF1,W
        xorlw    b'11111111'
        movwf    TMP
        rlf        TMP,F        ;bit 7
        rlf        S1A,F        ;GP4
        rlf        S1A,F        ;GP3
        rlf        TMP,F        ;bit 6
        rlf        S1B,F        ;GP4
        rlf        S1B,F        ;GP3
        rlf        TMP,F        ;bit 5
        rlf        S1A,F        ;GP2
        rlf        TMP,F        ;bit 4
        rlf        S1B,F        ;GP2
        rlf        TMP,F        ;bit 3
        rlf        S1A,F        ;GP1
        rlf        TMP,F        ;bit 2
        rlf        S1B,F        ;GP1
        rlf        TMP,F        ;bit 1
        rlf        S1A,F        ;GP0
        rlf        TMP,F        ;bit 0
        rlf        S1B,F        ;GP0
        bcf        S1A,d'5'    ;GP5 en sortie
        bcf        S1B,d'5'    ;GP5 en sortie

        movf    MOTIF2,W
        xorlw    b'11111111'
        movwf    TMP
        rrf        TMP,W
        rrf        TMP,F
        rrf        TMP,W
        rrf        TMP,F
        rlf        TMP,F        ;bit 7
        rlf        S2A,F        ;GP5
        rlf        S2A,F        ;GP4
        rlf        S2A,F        ;GP3
        rlf        TMP,F        ;bit 6
        rlf        S2B,F        ;GP5
        rlf        S2B,F        ;GP4
        rlf        S2B,F        ;GP3
        rlf        TMP,F        ;bit 5
        rlf        S2A,F        ;GP2
        rlf        TMP,F        ;bit 4
        rlf        S2B,F        ;GP2
        rlf        TMP,F        ;bit 3
        rlf        S2A,F        ;GP1
        rlf        TMP,F        ;bit 2
        rlf        S2B,F        ;GP1
        rlf        TMP,F        ;bit 1
        rlf        S2A,F        ;GP0
        rlf        TMP,F        ;bit 0
        rlf        S2B,F        ;GP0
        bcf        S2A,d'4'    ;GP4 en sortie
        bcf        S2B,d'4'    ;GP4 en sortie

        movf    MOTIF3,W
        xorlw    b'11111111'
        movwf    TMP
        swapf    TMP,F
        rlf        TMP,F        ;bit 7
        rlf        S3A,F        ;GP5
        rlf        TMP,F        ;bit 6
        rlf        S3B,F        ;GP5
        rlf        TMP,F        ;bit 5
        rlf        S3A,F        ;GP4
        rlf        S3A,F        ;GP3
        rlf        S3A,F        ;GP2
        rlf        TMP,F        ;bit 4
        rlf        S3B,F        ;GP4
        rlf        S3B,F        ;GP3
        rlf        S3B,F        ;GP2
        rlf        TMP,F        ;bit 3
        rlf        S3A,F        ;GP1
        rlf        TMP,F        ;bit 2
        rlf        S3B,F        ;GP1
        rlf        TMP,F        ;bit 1
        rlf        S3A,F        ;GP0
        rlf        TMP,F        ;bit 0
        rlf        S3B,F        ;GP0
        bcf        S3A,d'2'    ;GP2 en sortie
        bcf        S3B,d'2'    ;GP2 en sortie

        movf    MOTIF4,W
        xorlw    b'11111111'
        movwf    TMP
        rlf        TMP,W
        rlf        TMP,F
        rlf        TMP,W
        rlf        TMP,F
        rlf        TMP,F        ;bit 7
        rlf        S4A,F        ;GP5
        rlf        TMP,F        ;bit 6
        rlf        S4B,F        ;GP5
        rlf        TMP,F        ;bit 5
        rlf        S4A,F        ;GP4
        rlf        S4A,F        ;GP3
        rlf        TMP,F        ;bit 4
        rlf        S4B,F        ;GP4
        rlf        S4B,F        ;GP3
        rlf        TMP,F        ;bit 3
        rlf        S4A,F        ;GP2
        rlf        S4A,F        ;GP1
        rlf        TMP,F        ;bit 2
        rlf        S4B,F        ;GP2
        rlf        S4B,F        ;GP1
        rlf        TMP,F        ;bit 1
        rlf        S4A,F        ;GP0
        rlf        TMP,F        ;bit 0
        rlf        S4B,F        ;GP0
        bcf        S4A,d'1'    ;GP1 en sortie
        bcf        S4B,d'1'    ;GP1 en sortie

        movf    MOTIF5,W
        xorlw    b'11111111'
        movwf    TMP
        rlf        TMP,F        ;bit 7
        rlf        S5A,F        ;GP5
        rlf        TMP,F        ;bit 6
        rlf        S5B,F        ;GP5
        rlf        TMP,F        ;bit 5
        rlf        S5A,F        ;GP4
        rlf        S5A,F        ;GP3
        rlf        TMP,F        ;bit 4
        rlf        S5B,F        ;GP4
        rlf        S5B,F        ;GP3
        rlf        TMP,F        ;bit 3
        rlf        S5A,F        ;GP2
        rlf        TMP,F        ;bit 2
        rlf        S5B,F        ;GP2
        rlf        TMP,F        ;bit 1
        rlf        S5A,F        ;GP1
        rlf        S5A,F        ;GP0
        rlf        TMP,F        ;bit 0
        rlf        S5B,F        ;GP1
        rlf        S5B,F        ;GP0
        bcf        S5A,d'0'    ;GP0 en sortie
        bcf        S5B,d'0'    ;GP0 en sortie

        retlw    h'00'
;********************************************************************
Fin:
        end
